stages:
  - build
  - test
  - deploy

# -- build ------------------

.build: &build
  stage: build
  after_script:
    - ls -l dist/
  artifacts:
    expire_in: 3h
    paths:
      - dist

build:tarball:
  <<: *build
  image: ligo/software:el7
  script:
    - pip install wheel
    - python setup.py sdist bdist_wheel

build:el7:
  <<: *build
  image: ligo/software:el7
  before_script:
    - yum install -yq
          rpm-build
          epel-rpm-macros
          python-rpm-macros
          python3-rpm-macros
          python-setuptools
          python34-setuptools
          python2-six
          python34-six
          python2-urllib3
          python34-urllib3
  script:
    - python setup.py sdist
    - rpmbuild -tb dist/ligo-scald*.tar.gz
    - mv -v ~/rpmbuild/RPMS/*/python*-ligo-scald-*.rpm dist/
    - rm -rf dist/*.tar.gz

#-- begin debian section

.build:debian: &build_debian
  <<: *build
  before_script:
    - apt-get update -yqq
    - apt-get install -yq
          dpkg-dev
          debhelper
          dh-python
          python-all-dev
          python3-all-dev
          python-setuptools
          python3-setuptools
          python-six
          python3-six
          python-bottle 
          python3-bottle 
          lal-python
          lal-python3
          python-numpy
          python3-numpy
          python-yaml 
          python3-yaml 
          python-h5py 
          python3-h5py 
          python-ligo-common
          python3-ligo-common
          python-urllib3
          python3-urllib3
          help2man
  script:
    - pushd .
    - python setup.py sdist
    - version=$(python setup.py --version)
    - cd dist
    - tar -xf ligo-scald-${version}.tar.gz
    - cd ligo-scald-${version}
    - dpkg-buildpackage -us -uc -b
    - popd
    - rm -rf dist/ligo-scald*

build:debian:stretch:
  <<: *build_debian
  image: ligo/software:stretch

test:el7:
  stage: test
  image: ligo/software:el7
  before_script:
    - pip install urllib3
    - pip install .
  script:
    - export SCALDRC_PATH=etc/example_config.yml
    - python -m pytest -v --doctest-modules --ignore build/ --ignore dist/ --ignore setup.py

pages:
  stage: deploy
  image: ligo/software:el7
  before_script:
    - pip install .
    - yum -y install graphviz
    - pip install sphinx==1.7.9 sphinxcontrib-programoutput
  script:
    - cd doc; make html
    - cd ..; mv doc/build/html public/
  artifacts:
    paths:
    - public
  only:
    - master
    - schedules
